/*E12.h
Global defines and includes for the E12 driver
*/
#include <linux/module.h>/* include file for kernel development*/
#include <linux/kernel.h>/* printk and others*/
#include <linux/fs.h>    /* the file structure */
#include <linux/ioport.h> /* inb, outb */
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <asm/io.h> /*ioremap*/
#include <asm/uaccess.h>

/*global declarations*/
#define E12DEB "<1>" /*sets the level of the debug messaging*/
#define E12MAJORNUM 0 /*set to zero for dynamic major number allocation*/
#define E12NAME "37E12" /*driver name*/
#define E12_DRIVER_V "1.0"
#define E12_FIFO_SZ 1000
#define E12MAXBOARDS 4 //ISA bus maximum stack
#define E12_IOSIZE   4
#define UNSET       -1

/*Flags and bitmaps*/
#define SUCCESS 1
#define FAILURE 2

/* data status's*/
#define OLD  0/*old data, don't read it out*/
#define NEW  1/*new data, read it out*/
#define ON   1
#define OFF  0
#define TRUE 1
#define FALSE 0

/*debug macro printk if debugging is on, otherwise its a placeholder*/
//#define IO_DEBUG
//#define GEN_DEBUG
#define E12_MESSAGE

#undef IODEBUG
#ifdef IO_DEBUG
#define IODEBUG(fmt, args...) printk(E12DEB fmt, ## args)
#else 
#define IODEBUG(fmt, args...) 
#endif

#undef GENDEBUG
#ifdef GEN_DEBUG
#define GENDEBUG(fmt, args...) printk(E12DEB fmt, ## args)
#else 
#define GENDEBUG(fmt, args...) 
#endif

#undef E12MESSAGE
#ifdef E12_MESSAGE
#define E12MESSAGE(fmt, args...) printk(E12DEB fmt, ## args)
#else 
#define E12MESSAGE(fmt, args...) 
#endif
