/*E12_Interrupt.c
Interrupt routine for the 37E12
*/
#include "E12.h"
#include "E12fops.h"
#include "sE12.h"

void E12_Interrupt(int irq, void *dev_id, struct pt_regs *regs)
{
E12_device *device = dev_id;

IODEBUG("IRQ\n");

rmb();
if(MIRQ_LOW(device))
  {
    IODEBUG("empty IRQ\n");
    return;
    /*the empty IRQ which should result from a read/writes, and should always
     result from read/writes. Write is responsible for creating clear time 
     between handshake line pulses and valid IRQs*/
  }

/*fasync should go here*/
IODEBUG("kill_fasync\n");
if(device->dataready)
  kill_fasync(&device->dataready, SIGIO, POLL_IN);//notify async queue

if(device->valid==TRUE)
  wake_up_interruptible(&device->readqueue);

}



