/*E12fops.h
file operation prototypes for the 37E12 driver
*/

#define NUM(dev) (MINOR(dev) & 0xf)

typedef struct E12_device
{
int num;
char devicename[50];//string describing device
int IRQ;
unsigned char IRQedge;
int address;
u8  valid;
struct fasync_struct *dataready;
wait_queue_head_t readqueue;
}E12_device;


int E12_Open(struct inode *,struct file *);
int E12_Release(struct inode *, struct file *);
ssize_t E12_Read(struct file *, char *, size_t, loff_t *);
ssize_t E12_Write(struct file *, const char *, size_t, loff_t *);
int E12_Ioctl(struct inode *inode, struct file *filp, unsigned int cmd, unsigned long arg);
int E12_fasync(int fd, struct file *filp, int mode);
void E12_Interrupt(int irq, void *dev_id, struct pt_regs *regs);
