/* 37e12 device driver for generic hardware 
Nathan Gustavson 2003 Emac.inc
*/

#include "E12.h"
#include "E12fops.h"

int E12Major;

E12_device Global_E12device[E12MAXBOARDS];
extern struct file_operations E12fops;


static int Init_Device(E12_device *device, int number)
{
device->num       = number;
device->IRQ       = UNSET;
device->address   = UNSET;
device->valid     = UNSET;
device->dataready = NULL;
init_waitqueue_head(&device->readqueue);
sprintf(device->devicename,E12NAME"-%u",number);
return 0;
}

static int Init_Global_Devices(void)
{
int i;
for(i=0;i<E12MAXBOARDS;i++)
  Init_Device(&Global_E12device[i], i);
return 0;
}


int init_module(void)
{

SET_MODULE_OWNER(&E12fops);

  /* the drivers (main) function*/

E12MESSAGE(" "E12NAME " driver version " E12_DRIVER_V " (c) " __DATE__  "\n");
	printk(" N.Z. Gustavson (ngustavson@emacinc.com), Emac.inc\n");

E12Major = register_chrdev(E12MAJORNUM, E12NAME, &E12fops);

if(E12Major < 0)
  {
E12MESSAGE(E12NAME" driver failed to register Major Number"); 
return E12Major; /* in this case the E12Major is actually an error message*/
}
 
if(E12MAJORNUM!=0)
E12Major = E12MAJORNUM; /* if E12MAJORNUM is not zero this is a static allocation*/

Init_Global_Devices();
GENDEBUG(E12NAME" Driver Registered\n");


return 0;
}



/*cleanup_module
this routine is called when a module is unloaded with rmmod
*/
void cleanup_module(void)
{
  /* called whenever the driver is unloaded*/

unregister_chrdev(E12Major,E12NAME);
GENDEBUG(E12NAME" driver unloaded\n");
}

























